#include "jagobj.h"

long ObjSize(union ObjList *o)
{
   long size = 0;
   short type;

   do {
      type = o->type;
      o++;
      switch (type)
      {
         case OL_BITMAP:
            if (size & 15)
            {
               size = size + 8; /* align with a null branch object */
            }
            size += 16;
            break;
         case OL_SCALEBITMAP:
            while (size & 31)
            {
               size = size+8; /* align as needed */
            }
            size += 24;
            break;
         case OL_GPU:
         case OL_BRANCH:
         case OL_STOP:
            size += 8;
            break;
         default:
            break;
      }
   } while (type != OL_STOP);
   return size;
}
